package java.net;

import java.security.AccessController;
import sun.security.action.GetPropertyAction;
import java.nio.charset.UnsupportedCharsetException;
import java.nio.charset.IllegalCharsetNameException;
import java.nio.charset.Charset;
import java.io.CharArrayWriter;
import java.io.UnsupportedEncodingException;
import java.util.BitSet;

public class URLEncoder
{
    static BitSet dontNeedEncoding;
    static final int caseDiff = 32;
    static String dfltEncName;
    
    private URLEncoder() {
    }
    
    @Deprecated
    public static String encode(String s) {
        String encode = null;
        try {
            encode = encode(s, URLEncoder.dfltEncName);
        }
        catch (UnsupportedEncodingException ex) {}
        return encode;
    }
    
    public static String encode(String s, String s2) throws UnsupportedEncodingException {
        boolean n = false;
        StringBuffer sb = new StringBuffer(s.length());
        CharArrayWriter charArrayWriter = new CharArrayWriter();
        if (s2 == null) {
            throw new NullPointerException("charsetName");
        }
        Charset forName;
        try {
            forName = Charset.forName(s2);
        }
        catch (IllegalCharsetNameException ex) {
            throw new UnsupportedEncodingException(s2);
        }
        catch (UnsupportedCharsetException ex2) {
            throw new UnsupportedEncodingException(s2);
        }
        int i = 0;
        while (i < s.length()) {
            int n2 = s.charAt(i);
            if (URLEncoder.dontNeedEncoding.get(n2)) {
                if (n2 == 32) {
                    n2 = 43;
                    n = true;
                }
                sb.append((char)n2);
                ++i;
            }
            else {
                do {
                    charArrayWriter.write(n2);
                    if (n2 >= 55296 && n2 <= 56319 && i + 1 < s.length()) {
                        int char1 = s.charAt(i + 1);
                        if (char1 >= '?' && char1 <= '?') {
                            charArrayWriter.write(char1);
                            ++i;
                        }
                        else {
                            continue;
                        }
                    }
                    else {
                        continue;
                    }
                } while (++i < s.length() && !URLEncoder.dontNeedEncoding.get(n2 = s.charAt(i)));
                charArrayWriter.flush();
                byte[] bytes = new String(charArrayWriter.toCharArray()).getBytes(forName);
                for (int j = 0; j < bytes.length; ++j) {
                    sb.append('%');
                    int forDigit = Character.forDigit(bytes[j] >> 4 & 0xF, 16);
                    if (Character.isLetter((char)forDigit)) {
                        forDigit = (char)(forDigit - 32);
                    }
                    sb.append((char)forDigit);
                    int forDigit2 = Character.forDigit(bytes[j] & 0xF, 16);
                    if (Character.isLetter((char)forDigit2)) {
                        forDigit2 = (char)(forDigit2 - 32);
                    }
                    sb.append((char)forDigit2);
                }
                charArrayWriter.reset();
                n = true;
            }
        }
        return n ? sb.toString() : s;
    }
    
    static {
        URLEncoder.dfltEncName = null;
        URLEncoder.dontNeedEncoding = new BitSet(256);
        for (int i = 97; i <= 122; ++i) {
            URLEncoder.dontNeedEncoding.set(i);
        }
        for (int j = 65; j <= 90; ++j) {
            URLEncoder.dontNeedEncoding.set(j);
        }
        for (int k = 48; k <= 57; ++k) {
            URLEncoder.dontNeedEncoding.set(k);
        }
        URLEncoder.dontNeedEncoding.set(32);
        URLEncoder.dontNeedEncoding.set(45);
        URLEncoder.dontNeedEncoding.set(95);
        URLEncoder.dontNeedEncoding.set(46);
        URLEncoder.dontNeedEncoding.set(42);
        URLEncoder.dfltEncName = (String)AccessController.doPrivileged(new GetPropertyAction("file.encoding"));
    }
}
